/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.locojoy.base.Octets
 *  fire.log.enums.YYLoggerTuJingEnum
 *  fire.pb.activity.award.RewardMgr
 *  fire.pb.battle.pvp.EPvPType
 *  fire.pb.battle.pvp.PvPHelper
 *  fire.pb.circletask.PVPScoreAwardConfig
 *  fire.pb.item.Pack
 *  fire.pb.talk.MessageMgr
 *  fire.pb.util.MessageUtil
 *  mkdb.Lockeys
 *  mkdb.Procedure
 *  mkdb.TTable
 *  mkio.Protocol
 *  xtable.Locks
 *  xtable.Properties
 */
package fire.pb.battle.pvp5;

import com.locojoy.base.Octets;
import fire.log.enums.YYLoggerTuJingEnum;
import fire.pb.activity.award.RewardMgr;
import fire.pb.battle.pvp.EPvPType;
import fire.pb.battle.pvp.PvPHelper;
import fire.pb.battle.pvp5.PvP5RaceProxy;
import fire.pb.battle.pvp5.PvP5RoleProxy;
import fire.pb.battle.pvp5.SPvP5BattleInfo;
import fire.pb.circletask.PVPScoreAwardConfig;
import fire.pb.item.Pack;
import fire.pb.talk.MessageMgr;
import fire.pb.util.MessageUtil;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;
import mkdb.Lockeys;
import mkdb.Procedure;
import mkdb.TTable;
import mkio.Protocol;
import xtable.Locks;
import xtable.Properties;

public class PPvP5ProcessBattleResult
extends Procedure {
    public final int gradeId;
    public final List<Long> winnerIds;
    public final List<Long> loserIds;
    public final long winnerLeaderId;
    public final long loserLeaderId;
    public final long winnerTeamId;
    public final long loserTeamId;

    public PPvP5ProcessBattleResult(int gradeId, List<Long> winnerIds, List<Long> loserIds, long winnerLeaderId, long loserLeaderId, long winnerTeamId, long loserTeamId) {
        this.gradeId = gradeId;
        this.winnerIds = winnerIds;
        this.loserIds = loserIds;
        this.winnerLeaderId = winnerLeaderId;
        this.loserLeaderId = loserLeaderId;
        this.winnerTeamId = winnerTeamId;
        this.loserTeamId = loserTeamId;
    }

    public boolean process() {
        PvP5RaceProxy race = PvP5RaceProxy.getPvP5RaceProxy(this.gradeId);
        if (race.getXRace() == null) {
            return false;
        }
        HashSet<Long> roleIds = new HashSet<Long>();
        roleIds.addAll(this.winnerIds);
        roleIds.addAll(this.loserIds);
        if (this.loserIds.size() == 0) {
            roleIds.add(this.loserLeaderId);
        }
        Set<Long> broadcastSet = race.getBroadcastRoles(new HashSet<Long>());
        LinkedList<Long> teamIds = new LinkedList<Long>();
        if (this.winnerTeamId > 0L) {
            teamIds.add(this.winnerTeamId);
        }
        if (this.loserTeamId > 0L) {
            teamIds.add(this.loserTeamId);
        }
        if (teamIds.size() > 0) {
            this.lock(Lockeys.get((TTable)Locks.TEAMLOCK, teamIds));
        }
        this.lock(Lockeys.get((TTable)Locks.ROLELOCK, roleIds));
        int winnerScoreLv = 0;
        int loserScoreLv = 0;
        LinkedList<PvP5RoleProxy> winners = new LinkedList<PvP5RoleProxy>();
        for (long id : this.winnerIds) {
            PvP5RoleProxy winner = PvP5RoleProxy.getPvP5RoleProxy(id, false);
            winnerScoreLv += winner.getScoreLevel();
            if (winner.getRoleId() == this.winnerLeaderId) {
                winners.add(0, winner);
                continue;
            }
            winners.add(winner);
        }
        LinkedList<PvP5RoleProxy> losers = new LinkedList<PvP5RoleProxy>();
        ArrayList<Long> tempLoserIds = new ArrayList<Long>();
        tempLoserIds.addAll(this.loserIds);
        if (tempLoserIds.size() == 0) {
            tempLoserIds.add(this.loserLeaderId);
        }
        Iterator iterator = tempLoserIds.iterator();
        while (iterator.hasNext()) {
            long id = (Long)iterator.next();
            PvP5RoleProxy loser = PvP5RoleProxy.getPvP5RoleProxy(id, false);
            loserScoreLv += loser.getScoreLevel();
            if (loser.getRoleId() == this.loserLeaderId) {
                losers.add(0, loser);
                continue;
            }
            losers.add(loser);
        }
        if (this.winnerIds.size() > 0) {
            winnerScoreLv /= this.winnerIds.size();
        }
        if (this.loserIds.size() > 0) {
            loserScoreLv /= this.loserIds.size();
        }
        winnerScoreLv = Math.max(1, winnerScoreLv);
        loserScoreLv = Math.max(1, loserScoreLv);
        int winScore = this.getWinScore(winnerScoreLv, loserScoreLv);
        int loseScore = this.getLoseScore(winnerScoreLv, loserScoreLv);
        if (this.loserIds.size() == 0) {
            loseScore = 0;
        }
        this.processBattleWinType(race, winners, winScore, losers, loseScore, broadcastSet);
        return true;
    }

    private void processBattleWinType(PvP5RaceProxy race, List<PvP5RoleProxy> winners, int winScore, List<PvP5RoleProxy> losers, int loseScore, Set<Long> broadcastSet) {
        Pack bag;
        int score;
        PvP5RoleProxy loseLeader;
        PvP5RoleProxy winLeader = winners.size() > 0 ? winners.get(0) : null;
        PvP5RoleProxy pvP5RoleProxy = loseLeader = losers.size() > 0 ? losers.get(0) : null;
        if (winLeader == null || loseLeader == null) {
            return;
        }
        int winnerLevel = 0;
        int loserLevel = 0;
        for (PvP5RoleProxy roleProxy : winners) {
            winnerLevel += Properties.selectLevel((Long)roleProxy.getRoleId()).intValue();
        }
        for (PvP5RoleProxy roleProxy : losers) {
            loserLevel += Properties.selectLevel((Long)roleProxy.getRoleId()).intValue();
        }
        int winAwardId = PvPHelper.getAwardIdByRoleLevel((EPvPType)EPvPType.PVP5, (int)(winnerLevel /= winners.size()), (boolean)true, (int)winLeader.getExcellent());
        int loseAwardId = PvPHelper.getAwardIdByRoleLevel((EPvPType)EPvPType.PVP5, (int)(loserLevel /= losers.size()), (boolean)false, (int)loseLeader.getExcellent());
        this.awardAndSendMsg(winners, winAwardId, losers, loseAwardId, broadcastSet, winLeader.getContinueWinNum() + 1, loseLeader.getContinueWinNum());
        boolean isExcellent = winLeader.getExcellent() == 1;
        int winRongYu = winScore;
        int loseRongYu = loseScore;
        for (PvP5RoleProxy roleProxy : winners) {
            score = winScore;
            if (!isExcellent) {
                score = 0;
            }
            if (score > 0) {
                roleProxy.addScore(score, false);
            }
            if (winRongYu > 0) {
                bag = new Pack(roleProxy.getRoleId(), false);
                bag.addSysCurrency((long)winRongYu, 5, "PVP5Winer", YYLoggerTuJingEnum.tujing_Value_PVP5, 0);
                MessageUtil.pSendAddOrRemoveCurrency((long)roleProxy.getRoleId(), (long)winRongYu, (int)5);
            }
            roleProxy.onBattleEnd(true, this.loserLeaderId, score, race);
        }
        for (PvP5RoleProxy roleProxy : losers) {
            score = loseScore;
            if (!isExcellent) {
                score = 0;
            }
            if (score > 0) {
                roleProxy.addScore(score, false);
            }
            if (loseRongYu > 0) {
                bag = new Pack(roleProxy.getRoleId(), false);
                bag.addSysCurrency((long)loseRongYu, 5, "PVP5Loser", YYLoggerTuJingEnum.tujing_Value_PVP5, 0);
                MessageUtil.pSendAddOrRemoveCurrency((long)roleProxy.getRoleId(), (long)loseRongYu, (int)5);
            }
            roleProxy.onBattleEnd(false, this.winnerLeaderId, score, race);
        }
    }

    private void awardAndSendMsg(List<PvP5RoleProxy> winners, int winAward, List<PvP5RoleProxy> losers, int loseAward, Set<Long> broadcastSet, int continueWinNum, int endContinueWinNum) {
        PvP5RoleProxy loseLeader;
        PvP5RoleProxy winLeader = winners.size() > 0 ? winners.get(0) : null;
        PvP5RoleProxy pvP5RoleProxy = loseLeader = losers.size() > 0 ? losers.get(0) : null;
        if (winLeader == null || loseLeader == null) {
            return;
        }
        String winnerName = Properties.selectRolename((Long)winLeader.getRoleId());
        String loserName = Properties.selectRolename((Long)loseLeader.getRoleId());
        continueWinNum = Math.min(100, continueWinNum);
        HashMap<String, Integer> params = new HashMap<String, Integer>();
        params.put("PVPCnt", continueWinNum);
        params.put("PVPTargetCnt", endContinueWinNum);
        boolean isExcellent = winLeader.getExcellent() == 1;
        for (PvP5RoleProxy roleProxy : winners) {
            if (winAward > 0) {
                if (roleProxy.getBattleNum() + 1 <= 10) {
                    RewardMgr.getInstance().distributeAllAward(roleProxy.getRoleId(), winAward, params, YYLoggerTuJingEnum.tujing_Value_PVP5, 0, 4002, "PVP5胜利");
                }
            } else if (!isExcellent) {
                MessageMgr.psendMsgNotifyWhileCommit((long)roleProxy.getRoleId(), (int)172030);
            }
            this.sendRaceBattleInfo(roleProxy.getRoleId(), 160387, loserName, roleProxy.getBattleNum() + 1);
        }
        for (PvP5RoleProxy roleProxy : losers) {
            if (loseAward > 0) {
                if (roleProxy.getBattleNum() + 1 <= 10) {
                    RewardMgr.getInstance().distributeAllAward(roleProxy.getRoleId(), loseAward, params, YYLoggerTuJingEnum.tujing_Value_PVP5, 0, 4002, "PVP5失败");
                }
            } else if (!isExcellent) {
                MessageMgr.psendMsgNotifyWhileCommit((long)roleProxy.getRoleId(), (int)172030);
            }
            this.sendRaceBattleInfo(roleProxy.getRoleId(), 160388, winnerName, roleProxy.getBattleNum() + 1);
        }
        for (PvP5RoleProxy roleProxy : winners) {
            int roleContinueWinNum = roleProxy.getContinueWinNum() + 1;
            if (roleContinueWinNum < 5) continue;
            String roleName = Properties.selectRolename((Long)roleProxy.getRoleId());
            this.sendRaceBattleInfo(broadcastSet, 160389, roleName, roleContinueWinNum);
        }
        if (endContinueWinNum >= 5) {
            this.sendRaceBattleInfo(broadcastSet, 160390, winnerName, loserName, endContinueWinNum);
        }
    }

    private void sendRaceBattleInfo(Set<Long> broadcastSet, int msgId, Object ... params) {
        if (msgId <= 0) {
            return;
        }
        LinkedList<Octets> octetses = new LinkedList<Octets>();
        if (params != null) {
            for (Object parameter : params) {
                octetses.add(MessageMgr.convertString2Octets((String)parameter.toString()));
            }
        }
        SPvP5BattleInfo snd = new SPvP5BattleInfo();
        snd.ismine = 0;
        snd.msgid = msgId;
        snd.parameters.addAll(octetses);
        Procedure.psendWhileCommit(broadcastSet, (Protocol)snd);
    }

    private void sendRaceBattleInfo(long roleId, int msgId, Object ... params) {
        if (msgId <= 0) {
            return;
        }
        LinkedList<Octets> octetses = new LinkedList<Octets>();
        if (params != null) {
            for (Object parameter : params) {
                octetses.add(MessageMgr.convertString2Octets((String)parameter.toString()));
            }
        }
        SPvP5BattleInfo snd = new SPvP5BattleInfo();
        snd.ismine = 1;
        snd.msgid = msgId;
        snd.parameters.addAll(octetses);
        Procedure.psendWhileCommit((long)roleId, (Protocol)snd);
    }

    private int getWinScore(int winLevel, int loseLevel) {
        PVPScoreAwardConfig config = PvPHelper.getScoreAwardConfig((int)winLevel);
        int addScore = config.win;
        int levelSub = Math.abs(loseLevel - winLevel);
        if (levelSub == 0) {
            return addScore;
        }
        PVPScoreAwardConfig subConfig = PvPHelper.getScoreAwardConfig((int)levelSub);
        if (subConfig == null) {
            return addScore;
        }
        addScore = winLevel > loseLevel ? (addScore += subConfig.adwin) : (addScore += subConfig.diswin);
        return addScore;
    }

    private int getLoseScore(int winLevel, int loseLevel) {
        PVPScoreAwardConfig config = PvPHelper.getScoreAwardConfig((int)loseLevel);
        int addScore = config.lose;
        int levelSub = Math.abs(loseLevel - winLevel);
        if (levelSub == 0) {
            return addScore;
        }
        PVPScoreAwardConfig subConfig = PvPHelper.getScoreAwardConfig((int)levelSub);
        if (subConfig == null) {
            return addScore;
        }
        addScore = loseLevel > winLevel ? (addScore += subConfig.adlose) : (addScore += subConfig.dislose);
        return addScore;
    }
}

